_TITLE "Part 2 TrackWord Algo"
'started 2018-08-06 by bplus"
'QB64 X 64 version 1.2 20180228/86  from git b301f92

' Part 1 uses a recursive function to build a one time only Master Snake.txt file.
' what is that?
'
' for squares numbered
' 1 2 3
' 4 5 6
' 7 8 9
'
' the Master Snake file contains all possible connections you can make between squares, 10256.

' With that file you can translate the letters to square numbers as a sort of encryption or decryption.
' if M is in the 1 square translate all snakes with number 1 to M in 1 position
' if B is in the 2 square translate all snakes with number 2 to B in 2 position
' ... we leave that to the application file.


' Part 2
' Load the Master Snake.txt file into the snakes string array.
' Load the Dictionary into the words$ array.
' We get a 9 letter word to translate the snake square numbers to real facimiles of words.
' Use the snake2Word$ function to translate snake square numbers into Letters from theWord$.
' See if the word created is in words$ array with the found function (binary search).
' Collect real words into the sa array bin.
' QSort the sa array.
' Print out words from the sorted array only if the are unique and get a new cnt for unique words.
'


CONST ww = 800
CONST wh = 600
SCREEN _NEWIMAGE(ww, wh, 32)
_SCREENMOVE (1280 - ww) / 2 + 30, (760 - wh) / 2

' load snakes
REDIM SHARED snakes(12300) AS STRING
nSnakes& = fLines&("Master Snakes.txt", snakes())
'test load of snakes
'FOR i = nSnakes& - 10 TO nSnakes& - 1
'    PRINT snakes$(i)
'NEXT

'get wordlist from dictionary
DIM b9 AS STRING * 9
OPEN "dictionary.rnd" FOR RANDOM AS #1 LEN = 9
nWord& = LOF(1) / 9
DIM SHARED words$(nWord&)
FOR i = 1 TO nWord&
    GET #1, i, b9
    words$(i) = RTRIM$(b9)
NEXT
CLOSE #1

'check load of words$
ubw& = UBOUND(words$)
'FOR i = ubw - 10 TO ubw
'    PRINT words$(i)
'NEXT
'PRINT ubw '155237

DIM SHARED theWord$
theWord$ = "LOOPBPLUS" '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< Here is the 9 letter wordwe are tracking
REDIM SHARED sa(500) AS STRING ' the storage bin of word matches from dictionary
cnt = 0 'count matches
FOR i = 0 TO nSnakes& - 1 'go through all snake patterns
    wd$ = snake2word$(snakes(i)) 'translate pattern to word
    IF found%(wd$) = 1 THEN sa(cnt) = wd$: cnt = cnt + 1 'see if combination of letters is word in dictionary
NEXT

'sort the storage bin
QSort 0, cnt - 1
newCnt = 0: lastword$ = ""
FOR i = 0 TO cnt - 1 'print and count only non redundant words
    IF sa(i) <> lastword$ THEN PRINT sa(i),: newCnt = newCnt + 1: lastword$ = sa(i)
NEXT
PRINT: PRINT "Count:"; newCnt
'done!


FUNCTION snake2word$ (snake$)
    ' use the dim shared theWord$ to translate snake number string to letters
    FOR i = 1 TO LEN(snake$)
        c = VAL(MID$(snake$, i, 1))
        b$ = b$ + MID$(theWord$, c, 1)
    NEXT
    snake2word$ = b$
END FUNCTION

FUNCTION found% (w$)
    lo& = 0: hi& = UBOUND(words$)
    'FOR i = 0 TO UBOUND(words$) 'OK fuck it the dumb ass way!
    '    IF words$(i) = w$ THEN found% = 1: EXIT SUB
    'NEXT
    WHILE hi& - lo& > 1
        test& = (hi& - lo&) / 2 + lo&
        IF w$ = words$(test&) THEN
            found% = 1: EXIT FUNCTION
        ELSEIF w$ > words$(test&) THEN
            lo& = test&
        ELSE
            hi& = test&
        END IF
    WEND
    'if still here then
    found% = 0
END FUNCTION


'Load file into string array arr()
' Before calling:  REDIM arr(SomeNumberThatIsFarBiggerThanNeeded) AS STRING
' !!!  SomeNumberThatIsFarBiggerThanNeeded prevents having to REDIM array everytime add an item or 100 items...
' this function returns number of lines found (might have blank at end)
' !!! remember the array index for lines goes from 0 to filecount% -1
FUNCTION fLines& (fileName$, arr() AS STRING)
    filecount& = 0
    IF _FILEEXISTS(fileName$) THEN
        OPEN fileName$ FOR INPUT AS #1
        DO UNTIL EOF(1)
            LINE INPUT #1, arr(filecount&)
            'PRINT filecount&, arr(filecount&)
            filecount& = filecount& + 1
        LOOP
        CLOSE #1
        REDIM _PRESERVE arr(filecount& - 1)
    ELSE
        PRINT "Can't find file!"
    END IF
    fLines& = filecount& 'this file returns the number of lines loaded, 0 means file did not exist
END FUNCTION

SUB QSort (Start, Finish) 'sa$ needs to be shared array
    i = Start
    j = Finish
    x$ = sa$(INT((i + j) / 2))
    WHILE i <= j
        WHILE sa$(i) < x$
            i = i + 1
        WEND
        WHILE sa$(j) > x$
            j = j - 1
        WEND
        IF i <= j THEN
            a$ = sa$(i)
            sa$(i) = sa$(j)
            sa$(j) = a$
            i = i + 1
            j = j - 1
        END IF
    WEND
    IF j > Start THEN QSort Start, j
    IF i < Finish THEN QSort i, Finish
END SUB


